#include <stdio.h>
#include <stdlib.h>
#include <math.h>

void print_xy(const char *format, int precision, double x, double y) {
	printf("precision %2d: ", precision);
	printf(format, precision, x);
	printf(format, precision, y);
	printf("\n");
}

void print(const char *header, const char *format, double x, double y) {
	printf("%s:\n", header);
	print_xy(format, 3, x, y);
	print_xy(format, 6, x, y);
	print_xy(format, 9, x, y);
	printf("\n");
}

int main (void) {
	double x = sqrt(2.)*1e8, y = 5;

	print("Default notation(g)", "%20.*g", x, y);
	print("Default notation(#g)", "%#20.*g", x, y);
	print("Fixed notation(f)", "%20.*f", x, y);
	print("Scientific notation(e)", "%20.*e", x, y);

	return EXIT_SUCCESS;
}

